package me.omidius.omihealth;

import java.util.ArrayList;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.attribute.Attribute;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class Commands implements CommandExecutor {

	static Main plugin;
	public Commands(Main main) {
		plugin = main;
	}

	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {

		if (cmd.getName().equalsIgnoreCase("omihealth")) {
			if (sender instanceof Player) {
				Player p = (Player) sender;
				if (args.length == 0) {
					p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6Usage: &7/omihealth&7&o, &7/ohealth &7&oor &7/oh <gethp/sethp/item/reset/reload/help>"));
					return true;
				}
				if (args.length >= 1) {
					if (args[0].equalsIgnoreCase("reload")) {
						if (p.hasPermission("omihealth.reload")) {
							plugin.reloadConfig();
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.reload-message")));
							return true;
						}
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return true;
					}
					if (args[0].equalsIgnoreCase("sethp")) {
						if (p.hasPermission("omihealth.sethp")) {
							if(args.length <= 1) {
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',"&6Usage: &7/omihealth sethp <player> <amount>"));
								return true;
							}
							if (args.length == 2) {
								Player target = Bukkit.getPlayerExact(args[1]);
								if (target instanceof Player) {				
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',"&6Usage: &7/omihealth sethp <player> <amount>"));
									return true;

								} else {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&cInvalid or offline username, please try again."));
									return true;
								}
							}
							if (args.length >= 3) {
								Player target = Bukkit.getPlayerExact(args[1]);
								if (isInt(args[2])) {
									Integer amount = Integer.parseInt(args[2]);
									if (amount <= 60) {
										if (!target.getName().equals(p.getName())) {
											target.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(amount);
											target.setHealth(amount.doubleValue());
											p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&aYou have set &f" + target.getDisplayName() + "&a's health to &f&l" + amount));
											target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.set-health-message")).replaceAll("<amount>", amount.toString()));
											return true;
										}
										target.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(amount);
										target.setHealth(amount.doubleValue());
										target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.set-health-message")).replaceAll("<amount>", amount.toString()));
										return true;
									}
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cThe maximum amount you can set someone's health to is 60."));
									return true;
								} else {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cYou need to type a number to set an amount."));
									return true;
								}
							}
							return true;
						}
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return true;
					}
					if (args[0].equalsIgnoreCase("item")) {
						if (p.hasPermission("omihealth.item.get")) {
							if(args.length <= 1) {
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',"&6Usage: &7/omihealth item <player> <amount>"));
								return true;
							}
							if (args.length == 2) {
								Player target = Bukkit.getPlayerExact(args[1]);
								if (target instanceof Player) {
									ItemStack item = new ItemStack(Material.EXPERIENCE_BOTTLE);
									ItemMeta meta = item.getItemMeta();
									meta.setDisplayName(ChatColor.WHITE + "Health Upgrade");
									meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
									ArrayList<String> lore = new ArrayList<String>();
									lore.add(ChatColor.GRAY + "Consume me to gain");
									lore.add(ChatColor.GRAY + "some extra health!");
									meta.setLore(lore);
									item.setItemMeta(meta);
									if (!target.getName().equals(p.getName())) {
										target.getInventory().addItem(item);
										p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&aYou have given &r" + target.getDisplayName() +"&a a Health Upgrade item."));
										target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.upgrade-item-receive-message")));
										return true;
									}
									target.getInventory().addItem(item);
									target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.upgrade-item-receive-message")));
									return true;
								} else {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cInvalid or offline username, please try again."));
									return true;
								}
							}
							if (args.length >= 3) {
								Player target = Bukkit.getPlayerExact(args[1]);
								if (isInt(args[2])) {
									Integer amount = Integer.parseInt(args[2]);
									ItemStack item = new ItemStack(Material.EXPERIENCE_BOTTLE,amount);
									ItemMeta meta = item.getItemMeta();
									meta.setDisplayName(ChatColor.WHITE + "Health Upgrade");
									meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
									ArrayList<String> lore = new ArrayList<String>();
									lore.add(ChatColor.GRAY + "Consume me to gain");
									lore.add(ChatColor.GRAY + "some extra health!");
									meta.setLore(lore);
									item.setItemMeta(meta);
									if (!target.getName().equals(p.getName())) {
										target.getInventory().addItem(item);
										p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&aYou have given&r " + target.getDisplayName() +" &f&l"+ amount + " &aHealth Upgrade items."));
										target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.multiple-items-receive-message")).replaceAll("<amount>", amount.toString()));
										return true;
									}
									target.getInventory().addItem(item);
									target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.multiple-items-receive-message")).replaceAll("<amount>", amount.toString()));
									return true;
								} else {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cYou need to type a number to set an amount."));
									return true;
								}
							}
							return true;
						}
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return true;
					}
					if (args[0].equalsIgnoreCase("gethp")) {
						if (p.hasPermission("omihealth.gethp")) {
							if(args.length <= 1) {
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',"&6Usage: &7/omihealth gethp <player>"));
								return true;
							}
							if (args.length >= 2) {
								Player target = Bukkit.getPlayerExact(args[1]);
								if (target instanceof Player) {
									Double healthNum = target.getHealth();
									String health = healthNum.toString();
									Double maxHealthNum = target.getAttribute(Attribute.GENERIC_MAX_HEALTH).getValue();
									String maxHealth = maxHealthNum.toString();
									if (!target.getName().equals(p.getName())) {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + target.getDisplayName() + "&f's health is currently &b" + health + "&f&l&o/&b" + maxHealth + "&f."));
									return true;
									}
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&fYour health is currently &b" + health + "&f&l&o/&b" + maxHealth + "&f."));
									return true;
								} else {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cInvalid or offline username, please try again."));
									return true;
								}
							}
							return true;
						}
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return true;
					}
					if (args[0].equalsIgnoreCase("reset")) {
						if (p.hasPermission("omihealth.reset")) {
							if(args.length <= 1) {
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',"&6Usage: &7/omihealth reset <player>"));
								return true;
							}
							if (args.length >= 2) {
								Player target = Bukkit.getPlayerExact(args[1]);
								if (target instanceof Player) {
									if (!target.getName().equals(p.getName())) {
										p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + target.getDisplayName() + "&c's health has been reset back to default."));
										target.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.reset-health-message")));
										target.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(20);
										return true;
									}
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cYour health has been reset back to default."));
									target.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(20);
									return true;
								} else {
									p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + "&cInvalid or offline username, please try again."));
									return true;
								}
							}
							return true;
						}
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return true;
					}
					if (args[0].equalsIgnoreCase("help")) {
						if (p.hasPermission("omihealth.help")) {
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&f&lOmi&c&lHealth &e&lHelp Page:"));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6/omihealth gethp <player> &7- &fChecks the HP of the target player."));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6/omihealth sethp <player> <amount> &7- &fSets the target player's HP."));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6/omihealth item <player> <amount> &7- &fGives the Health Upgrade item."));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6/omihealth reset <player> &7- &fResets the player's HP back to default."));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6/omihealth reload &7- &fReload the config.yml for the OmiHealth plugin."));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&6/omihealth help &7- &fBrings back this help page for you to see again."));
							p.sendMessage(ChatColor.translateAlternateColorCodes('&', "&e&oThat's all the commands for OmiHealth!"));
							return true;
						}
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return true;
					}
				}
				return true;
			}
			sender.sendMessage(ChatColor.RED + "Sorry, you cannot perform this command from the console.");
		}
		return false;
	}

	public static boolean isInt(String s) {
		try {
			Integer.parseInt(s);
		} catch (NumberFormatException nfe) {
			return false;
		}
		return true;
	}

}


