package me.omidius.omihealth;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerJoinEvent;

public class Events implements Listener{

	static Main plugin;
	public Events(Main main) {
		plugin = main;
	}
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent e) {
		Player p = e.getPlayer();
		Double amount = Double.parseDouble(plugin.getConfig().getString("Options.new-player-starting-hp"));
		if (!(p.hasPlayedBefore())) {
			p.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(amount);
		}
	}

	@EventHandler
	public void onItemUse(PlayerInteractEvent e) {
		if (e.getAction() == Action.LEFT_CLICK_AIR || e.getAction() == Action.LEFT_CLICK_BLOCK
				|| e.getAction() == Action.RIGHT_CLICK_AIR || e.getAction() == Action.RIGHT_CLICK_BLOCK) {
			Player p = e.getPlayer();
			if (p.getInventory().getItemInMainHand().getType() == Material.EXPERIENCE_BOTTLE) {
				if (p.getInventory().getItemInMainHand().getItemMeta().getDisplayName().contains("Health Upgrade")) {
					if (p.getInventory().getItemInMainHand().getItemMeta().hasLore()) {
						if (p.hasPermission("omihealth.item.use")) {
							if (p.getAttribute(Attribute.GENERIC_MAX_HEALTH).getBaseValue() <= 59) {
								e.setCancelled(true);
								p.getInventory().getItemInMainHand().setAmount(p.getInventory().getItemInMainHand().getAmount()-1);
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.upgrade-item-use-message")));
								p.getAttribute(Attribute.GENERIC_MAX_HEALTH).setBaseValue(p.getAttribute(Attribute.GENERIC_MAX_HEALTH).getBaseValue()+2);
								return;
							}
							e.setCancelled(true);
							p.sendMessage(ChatColor.RED+"Sorry, you already have the maximum amount of health.");
							return;
						}
						e.setCancelled(true);
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',plugin.getConfig().getString("Options.prefix") + plugin.getConfig().getString("Options.no-permissions-message")));
						return;
					}
				}
			}
		}

	}

}
